searchData={"items":[{"type":"module","title":"Xander.Config","doc":"This module provides functions to configure the Xander client.","ref":"Xander.Config.html"},{"type":"module","title":"Examples - Xander.Config","doc":"","ref":"Xander.Config.html#module-examples"},{"type":"module","title":"Connecting to a local Cardano node: - Xander.Config","doc":"# Use default configuration\n    path = \"/tmp/cardano-node.socket\"\n    config = Xander.Config.default_config!(path)\n    {:ok, pid} = Xander.Query.start_link(config)\n\n    # Or customize the configuration\n    path = \"/tmp/cardano-node.socket\"\n    config = Xander.Config.default_config!(path, :preview)\n\n    {:ok, pid} = Xander.Query.start_link(config)","ref":"Xander.Config.html#module-connecting-to-a-local-cardano-node"},{"type":"module","title":"Connecting to a Demeter node: - Xander.Config","doc":"# Configure for Demeter\n    url = \"https://your-demeter-url.demeter.run\"\n    config = Xander.Config.demeter_config!(url)\n\n    {:ok, pid} = Xander.Query.start_link(config)\n\n    # Query the current era\n    {:ok, current_era} = Xander.Query.query(pid, :get_current_era)","ref":"Xander.Config.html#module-connecting-to-a-demeter-node"},{"type":"function","title":"Xander.Config.default_config!/2","doc":"Returns the default configuration for connecting to a Cardano node.","ref":"Xander.Config.html#default_config!/2"},{"type":"function","title":"Xander.Config.demeter_config!/2","doc":"Returns configuration for connecting to a Demeter node.","ref":"Xander.Config.html#demeter_config!/2"},{"type":"module","title":"Xander.Handshake.Proposal","doc":"Builds handshake messages for node-to-client communication.","ref":"Xander.Handshake.Proposal.html"},{"type":"type","title":"Xander.Handshake.Proposal.network_type/0","doc":"","ref":"Xander.Handshake.Proposal.html#t:network_type/0"},{"type":"function","title":"Xander.Handshake.Proposal.version_message/2","doc":"Version numbers must be unique and appear in ascending order.","ref":"Xander.Handshake.Proposal.html#version_message/2"},{"type":"module","title":"Xander.Handshake.Response","doc":"This module is responsible for validating and parsing the\nhandshake response from a Cardano node.","ref":"Xander.Handshake.Response.html"},{"type":"function","title":"Xander.Handshake.Response.validate/1","doc":"Validates the handshake response from a Cardano node.","ref":"Xander.Handshake.Response.html#validate/1"},{"type":"module","title":"Xander.Messages","doc":"This module builds protocol messages ready to be sent to the server.","ref":"Xander.Messages.html"},{"type":"function","title":"Xander.Messages.get_current_block_height/0","doc":"Builds a static query to get the current block height.\n\nPayload CBOR: [3, [2]]\nPayload Bitstring: <<130, 3, 129, 2>>","ref":"Xander.Messages.html#get_current_block_height/0"},{"type":"function","title":"Examples - Xander.Messages.get_current_block_height/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.get_current_block_height()\n  iex> msg\n  <<0, 7, 0, 4, 130, 3, 129, 2>>","ref":"Xander.Messages.html#get_current_block_height/0-examples"},{"type":"function","title":"Xander.Messages.get_current_era/0","doc":"Builds a static query to get the current era.\n\nPayload CBOR: [3, [0, [2, [1]]]]\nPayload Bitstring: <<130, 3, 130, 0, 130, 2, 129, 1>>","ref":"Xander.Messages.html#get_current_era/0"},{"type":"function","title":"Examples - Xander.Messages.get_current_era/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.get_current_era()\n  iex> msg\n  <<0, 7, 0, 8, 130, 3, 130, 0, 130, 2, 129, 1>>","ref":"Xander.Messages.html#get_current_era/0-examples"},{"type":"function","title":"Xander.Messages.get_current_tip/0","doc":"Builds a static query to get the current tip of the chain\n\nPayload CBOR: [3]\nPayload Bitstring: <<129, 3>>","ref":"Xander.Messages.html#get_current_tip/0"},{"type":"function","title":"Examples - Xander.Messages.get_current_tip/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.get_current_tip()\n  iex> msg\n  <<0, 7, 0, 4, 130, 3, 129, 3>>","ref":"Xander.Messages.html#get_current_tip/0-examples"},{"type":"function","title":"Xander.Messages.get_epoch_number/0","doc":"Builds a static query to get the current epoch number.\n\nPayload CBOR: [3, [0, [0, [6, [1]]]]]\nPayload Bitstring: <<130, 3, 130, 0, 130, 0, 130, 6, 129, 1>>","ref":"Xander.Messages.html#get_epoch_number/0"},{"type":"function","title":"Examples - Xander.Messages.get_epoch_number/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.get_epoch_number()\n  iex> msg\n  <<0, 7, 0, 10, 130, 3, 130, 0, 130, 0, 130, 6, 129, 1>>","ref":"Xander.Messages.html#get_epoch_number/0-examples"},{"type":"function","title":"Xander.Messages.msg_acquire/0","doc":"Acquires a snapshot of the mempool, allowing the protocol to make queries.","ref":"Xander.Messages.html#msg_acquire/0"},{"type":"function","title":"Examples - Xander.Messages.msg_acquire/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.msg_acquire()\n    iex> msg\n    <<0, 7, 0, 2, 129, 8>>","ref":"Xander.Messages.html#msg_acquire/0-examples"},{"type":"function","title":"Xander.Messages.msg_release/0","doc":"Releases the current snapshot of the mempool, allowing the protocol to return\nto the idle state.","ref":"Xander.Messages.html#msg_release/0"},{"type":"function","title":"Examples - Xander.Messages.msg_release/0","doc":"iex> <<_timestamp::32, msg::binary>> = Xander.Messages.msg_release()\n    iex> msg\n    <<0, 7, 0, 2, 129, 5>>","ref":"Xander.Messages.html#msg_release/0-examples"},{"type":"module","title":"Xander.Query","doc":"Issues ledger queries to a Cardano node using the Node-to-Client (n2c) protocol.\nThis module implements the `gen_statem` behaviour.","ref":"Xander.Query.html"},{"type":"function","title":"Xander.Query.child_spec/1","doc":"Returns a child specification for the process. This determines the\nconfiguration of the OTP process when it is started by its parent.","ref":"Xander.Query.html#child_spec/1"},{"type":"function","title":"Xander.Query.connected/3","doc":"Emits events when in the `connected` state. Must transition to the\n`established_has_agency` state prior to sending queries to the node.","ref":"Xander.Query.html#connected/3"},{"type":"function","title":"Xander.Query.disconnected/3","doc":"Emits events when in the `disconnected` state.","ref":"Xander.Query.html#disconnected/3"},{"type":"function","title":"Xander.Query.established_has_agency/3","doc":"Emits events when in the `established_has_agency` state. Can send queries\nto the node when in this state.","ref":"Xander.Query.html#established_has_agency/3"},{"type":"function","title":"Xander.Query.established_no_agency/3","doc":"Emits events when in the `established_no_agency` state.","ref":"Xander.Query.html#established_no_agency/3"},{"type":"function","title":"Xander.Query.run/2","doc":"Sends a query to the connected Cardano node.\n\nAvailable queries are:\n\n  * `:get_current_era`\n  * `:get_current_block_height`\n  * `:get_epoch_number`\n  * `:get_current_tip`\n\nFor example:\n\n```elixir\nXander.Query.run(pid, :get_epoch_number)\n```","ref":"Xander.Query.html#run/2"},{"type":"function","title":"Xander.Query.start_link/1","doc":"Starts a new query process.","ref":"Xander.Query.html#start_link/1"},{"type":"module","title":"Xander.Query.Response","doc":"","ref":"Xander.Query.Response.html"},{"type":"type","title":"Xander.Query.Response.cbor/0","doc":"","ref":"Xander.Query.Response.html#t:cbor/0"},{"type":"function","title":"Xander.Query.Response.parse_response/1","doc":"Parses the response from a query. Accepts CBOR encoded responses.","ref":"Xander.Query.Response.html#parse_response/1"},{"type":"module","title":"Xander.Util","doc":"","ref":"Xander.Util.html"},{"type":"function","title":"Xander.Util.plex/1","doc":"Unwrap the multiplexer header from a CDDL message. This can be used to\nextract the payload from node responses.","ref":"Xander.Util.html#plex/1"},{"type":"function","title":"Examples - Xander.Util.plex/1","doc":"iex> Xander.Util.plex(<<0, 0, 0, 0, 1, 2, 0, 3, 97, 98, 99>>)\n    %{payload: <<97, 98, 99>>, protocol_id: <<1, 2>>, size: <<0, 3>>}","ref":"Xander.Util.html#plex/1-examples"},{"type":"extras","title":"Xander","doc":"# Xander\n\n![CI Status](https://github.com/wowica/xander/actions/workflows/ci.yml/badge.svg)\n[![Version](https://img.shields.io/hexpm/v/xander.svg)](https://hex.pm/packages/xander)\n\nElixir client for Cardano's Ouroboros networking protocol.\n\n⚠️ This project is under active development. For a more stable solution to connect to a Cardano node using Elixir, see [Xogmios](https://github.com/wowica/xogmios).","ref":"readme.html"},{"type":"extras","title":"Quickstart - Xander","doc":"Below is an example of how to connect to a Cardano node and run a query that returns the current tip of the ledger, similar to a `cardano-cli query tip` command.\n\n```elixir\n$ iex\n> Mix.install([{:xander, \"~> 0.1.0\"}])\n> # Must be a valid Unix socket path\n> # to a fully synced Cardano node\n> socket_path = \"/path/to/cardano-node.socket\"\n> config = Xander.Config.default_config!(socket_path)\n[\n  network: :mainnet,\n  path: [socket_path: \"/tmp/cardano-node.socket\"],\n  port: 0,\n  type: :socket\n]\n> {:ok, pid} = Xander.Query.start_link(config)\n{:ok, #PID<0.207.0>}\n> Xander.Query.run(pid, :get_current_tip)\n{:ok,\n {147911158, \"b2a4f78539559866281d6089143fa4c99db90b7efc4cf7787777f927967f0c8a\"}}\n```\n\nFor a more detailed description of different ways to use this library, read the following sections:\n\n\n1. [Running via Docker](#running-via-docker)\n2. [Running natively with an Elixir local dev environment](#running-natively-with-an-elixir-local-dev-environment)","ref":"readme.html#quickstart"},{"type":"extras","title":"Running via Docker - Xander","doc":"","ref":"readme.html#running-via-docker"},{"type":"extras","title":"Using Demeter.run - Xander","doc":"The demo application can connect to a Cardano node at [Demeter.run](https://demeter.run/) 🪄 \n\nFirst, create a Node on Demeter. Then, set your Node's url in the `DEMETER_URL` environment variable in the `.env` file. \n\nFor example:\n\n```bash\nDEMETER_URL=https://your-node-at.demeter.run\n```\n\nThen, run the application using Docker Compose:\n\n```bash\ndocker compose up --build\n```\n\n#### Via local UNIX socket\n\n🚨 **Note:** Socket files mapped via socat/ssh tunnels **DO NOT WORK** when using containers on OS X.\n\nUncomment the `volumes` section in the `compose.yml` file to mount the local UNIX socket to the container's socket path.\n\n```yml\nvolumes:\n  - /path/to/node.socket:/tmp/cardano-node.socket\n```\n\nThen, run the application using Docker Compose:\n```bash\ndocker compose up --build\n```","ref":"readme.html#using-demeter-run"},{"type":"extras","title":"Running natively with an Elixir local dev environment - Xander","doc":"#### Via local UNIX socket\n\nRun the following command using your own Cardano node's socket path:\n\n```bash\nCARDANO_NODE_PATH=/your/cardano/node.socket elixir run.exs\n```\n\n##### Setting up Unix socket mapping\n\nThis is useful if you want to run the application on a server different from your Cardano node.\n\n🚨 **Note:** Socket files mapped via socat/ssh tunnels **DO NOT WORK** when using containers on OS X.\n\n1. Run socat on the remote server with the following command:\n\n```bash\nsocat TCP-LISTEN:3002,reuseaddr,fork UNIX-CONNECT:/home/cardano_node/socket/node.socket\n```\n\n2. Run socat on the local machine with the following command:\n\n```bash\nsocat UNIX-LISTEN:/tmp/cardano_node.socket,reuseaddr,fork TCP:localhost:3002\n```\n\n3. Start an SSH tunnel from the local machine to the remote server with the following command:\n\n```bash\nssh -N -L 3002:localhost:3002 user@remote-server-ip\n```\n\n#### Using Demeter.run\n\nTo connect to a node at Demeter.run, set `DEMETER_URL` to your Node Demeter URL.\n\n```bash\nDEMETER_URL=https://your-node-at.demeter.run mix query_current_era\n```","ref":"readme.html#running-natively-with-an-elixir-local-dev-environment"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}